﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;

static class connection_builder
{
    private static readonly string connection_string;

    static connection_builder()
    {
        using (var local_conn = new SqlConnection("context connection = true"))
        {
            local_conn.Open();
            var comm = new SqlCommand();
            comm.Connection = local_conn;
            comm.CommandText = 
                @"SELECT 
                    @server_name = @@SERVERNAME, 
                    @db_name = DB_NAME()";

            comm.Parameters.Add("@server_name", System.Data.SqlDbType.VarChar, 128).Direction = System.Data.ParameterDirection.Output;
            comm.Parameters.Add("@db_name", System.Data.SqlDbType.VarChar, 128).Direction = System.Data.ParameterDirection.Output;
            comm.ExecuteNonQuery();

            SqlConnectionStringBuilder sb = new SqlConnectionStringBuilder();
            sb.DataSource = (string)comm.Parameters[0].Value;
            sb.InitialCatalog = (string)comm.Parameters[1].Value;
            sb.IntegratedSecurity = true;
            sb.Enlist = false;

            connection_string = sb.ConnectionString;
        }
    }

    public static SqlConnection get_loopback_connection()
    {
        return (new SqlConnection(connection_string));
    }
}
